'use strict';

var _export = require('./export-0fe6e142.js');
var web_domCollections_forEach = require('./web.dom-collections.for-each-e2b90693.js');

var nativeJoin = [].join;

var ES3_STRINGS = _export.IndexedObject != Object;
var STRICT_METHOD = web_domCollections_forEach.arrayMethodIsStrict('join', ',');

// `Array.prototype.join` method
// https://tc39.github.io/ecma262/#sec-array.prototype.join
_export.$({ target: 'Array', proto: true, forced: ES3_STRINGS || !STRICT_METHOD }, {
  join: function join(separator) {
    return nativeJoin.call(_export.toIndexedObject(this), separator === undefined ? ',' : separator);
  }
});
