'use strict';

var _export = require('./export-0fe6e142.js');
var web_domCollections_iterator = require('./web.dom-collections.iterator-4a803988.js');

var FAILS_ON_PRIMITIVES = _export.fails(function () { web_domCollections_iterator.nativeGetPrototypeOf(1); });

// `Object.getPrototypeOf` method
// https://tc39.github.io/ecma262/#sec-object.getprototypeof
_export.$({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES, sham: !web_domCollections_iterator.CORRECT_PROTOTYPE_GETTER }, {
  getPrototypeOf: function getPrototypeOf(it) {
    return web_domCollections_iterator.nativeGetPrototypeOf(_export.toObject(it));
  }
});

// `Object.setPrototypeOf` method
// https://tc39.github.io/ecma262/#sec-object.setprototypeof
_export.$({ target: 'Object', stat: true }, {
  setPrototypeOf: web_domCollections_iterator.setPrototypeOf
});
