'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _export = require('./export-0fe6e142.js');
var arrayMethodHasSpeciesSupport = require('./array-method-has-species-support-9edd0ecd.js');
var web_domCollections_forEach = require('./web.dom-collections.for-each-e2b90693.js');
var arrayMethodUsesToLength = require('./array-method-uses-to-length-11844004.js');
require('./web.dom-collections.iterator-4a803988.js');
require('./es.array.concat-2cd183db.js');
require('./es.array.index-of-5554a592.js');
require('./es.object.to-string-0ac89662.js');
require('./es.regexp.to-string-9e3df5de.js');
require('./es.function.name-154a69d5.js');
require('./es.object.define-property-aad2ae5c.js');
require('./es.object.set-prototype-of-0c1816f8.js');
var es_string_match = require('./es.string.match-ce60128e.js');
var React = require('react');
var React__default = _interopDefault(React);
require('./es.promise-14a9b921.js');
var immutable = require('immutable');
require('react-router-dom');
var moment = _interopDefault(require('moment'));
require('pull-person');
require('pull-person-mobile');
require('qnn-tree');
require('./es.array.map-0663019f.js');
require('antd/es/message/style/css');
var _message = _interopDefault(require('antd/es/message'));
require('./es.array.splice-58c5e38f.js');
var styleInject_es = require('./style-inject.es-17c48081.js');
require('./es.array.join-78b5edaa.js');
require('antd-mobile/es/toast/style/css');
var _Toast = _interopDefault(require('antd-mobile/es/toast'));
require('antd/es/notification/style/css');
var _notification = _interopDefault(require('antd/es/notification'));
require('antd/es/modal/style/css');
var _Modal2 = _interopDefault(require('antd/es/modal'));
require('antd-mobile/es/modal/style/css');
var _Modal = _interopDefault(require('antd-mobile/es/modal'));
var $ = _interopDefault(require('jquery'));
require('./runtime-72d72705.js');

//获取当前使用的是移动端还是PC端
var getDeviceType = function getDeviceType() {
  //平台、设备和操作系统
  // var system = {
  //     win: false,
  //     mac: false,
  //     xll: false
  // };
  // //检测平台
  // var p = navigator.platform;
  // system.win = p.indexOf("Win") === 0;
  // system.mac = p.indexOf("Mac") === 0;
  // system.x11 = (p === "X11") || (p.indexOf("Linux") === 0);
  // if (system.win || system.mac || system.xll) {
  //     //PC端
  //     return 'pc'
  // } else { 
  //     return 'mobile'
  // }
  //简单判断
  if (navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i)) {
    return 'mobile';
  } else {
    return 'pc';
  }
};

var getRules = function getRules(_ref) {
  var type = _ref.type,
      required = _ref.required,
      message = _ref.message,
      typeMessage = _ref.typeMessage,
      diyRules = _ref.diyRules,
      btnfns = _ref.btnfns;

  if (diyRules) {
    return diyRules({
      type: type,
      required: required,
      message: message,
      typeMessage: typeMessage,
      diyRules: diyRules,
      btnfns: btnfns
    });
  }

  var basic = [{
    required: required,
    message: message
  }];

  switch (type) {
    case "radio":
    case "checkbox":
    case "switch":
    case "rate":
    case "slider":
    case "money":
    case "textarea":
    case "textArea":
    case "password":
    case "files":
    case "filesDragger":
    case "images":
    case "camera":
    case "treeSelect":
    case "treeNode":
    case "item":
    case "select":
    case "cascader":
    case "selectByPaging":
    case "time":
    case "month":
    case "date":
    case "year":
    case "datetime":
    case "week":
    case "rangeDate":
    case "richtext":
    case "qnnTable":
      //这些组件不需要验证格式所以无需做操作 但是需要在这里隔离开
      break;

    case "identity":
      basic.push({
        pattern: new RegExp(/^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$|^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|X)$/),
        message: "请输入正确的身份证号码格式"
      });
      break;
    // 军官证或士兵证

    case "officers":
      basic.push({
        pattern: new RegExp(/^[a-zA-Z0-9]{7,21}$/),
        message: "证件号码格式错误"
      });
      break;
    // 台湾居民身份证

    case "taiWanIdentity":
      basic.push({
        pattern: new RegExp(/^[a-zA-Z][0-9]{9}$/),
        message: "证件号码格式错误"
      });
      break;
    // 香港永久性居民身份证

    case "hongKongPerpetualIdentity":
      basic.push({
        pattern: new RegExp(/^((\s?[A-Za-z])|([A-Za-z]{2}))\d{6}(\([0−9aA]\)|[0-9aA])$/),
        message: "证件号码格式错误"
      });
      break;
    // 护照

    case "passport":
      basic.push({
        validator: function validator(rule, value, callback) {
          if (value) {
            var reg1 = new RegExp(/^[a-zA-Z0-9]{7,21}$/);
            var reg2 = new RegExp(/^(P\d{7})|(G\d{8})$/);

            if (!reg1.test(value) && !reg2.test(value)) {
              return Promise.reject("请输入正确的格式");
            }
          } // // Note: 必须总是返回一个 callback，否则 validateFieldsAndScroll 无法响应


          return Promise.resolve();
        }
      });
      break;
    // 户口本

    case "householdRegister":
      basic.push({
        pattern: new RegExp(/^[a-zA-Z0-9]{3,21}$/),
        message: "证件号码格式错误"
      });
      break;
    // 出生证

    case "birthCertificate":
      basic.push({
        pattern: new RegExp(/^[a-zA-Z0-9]{5,21}$/),
        message: "证件号码格式错误"
      });
      break;
    // 邮政编码

    case "postalCode":
      basic.push({
        pattern: new RegExp(/^[0-9][0-9]{3,5}$/),
        message: "格式错误"
      });
      break;
    //手机和座机

    case "phone":
      basic.push({
        validator: function validator(rule, value) {
          if (value) {
            var phoneReg = new RegExp(/^1(?:3\d|4[4-9]|5[0-35-9]|6[[2,5,6,7]|7[013-8]|8\d|9\d)\d{8}$/);
            var specialPlaneReg = new RegExp(/^0\d{2,3}-\d{7,8}$/);

            if (!phoneReg.test(value) && !specialPlaneReg.test(value)) {
              return Promise.reject("请输入正确的格式");
            }
          }

          return Promise.resolve();
        }
      });
      break;
    //仅仅验证手机

    case "phoneOnly":
      basic.push({
        pattern: new RegExp(/^1(?:3\d|4[4-9]|5[0-35-9]|6[67]|7[013-8]|8\d|9\d)\d{8}$/),
        message: "请输入正确的手机号格式"
      });
      break;
    //座机

    case "specialPlane":
      basic.push({
        pattern: new RegExp(/^0\d{2,3}-\d{7,8}$/),
        message: "请输入正确的座机号码格式"
      });
      break;
    //火车车次

    case "trainNumber":
      basic.push({
        pattern: new RegExp(/^[GCDZTSPKXLY1-9]\d{1,4}$/),
        message: "请输入正确的火车车次格式"
      });
      break;
    //手机机身码

    case "phoneBodyCode":
      basic.push({
        pattern: new RegExp(/^\d{15,17}$/),
        message: "请输入正确的手机机身码格式"
      });
      break;
    //统一社会信用代码

    case "creditCode":
      basic.push({
        pattern: new RegExp(/^[0-9A-HJ-NPQRTUWXY]{2}\d{6}[0-9A-HJ-NPQRTUWXY]{10}$/),
        message: "请输入正确的统一社会信用代码格式"
      });
      break;
    //qq

    case "qq":
      basic.push({
        pattern: new RegExp(/^[1-9][0-9]{4,10}$/),
        message: "请输入正确的qq号码格式"
      });
      break;

    case "weixin":
      basic.push({
        pattern: new RegExp(/^[a-zA-Z][-_a-zA-Z0-9]{5,19}$/),
        message: "请输入正确的微信码格式"
      });
      break;
    //车牌号(新能源+非新能源)

    case "licensePlateNumber":
      basic.push({
        pattern: new RegExp(/^(?:[京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼使领 A-Z]{1}[A-HJ-NP-Z]{1}(?:(?:[0-9]{5}[DF])|(?:[DF](?:[A-HJ-NP-Z0-9])[0-9]{4})))|(?:[京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼使领 A-Z]{1}[A-Z]{1}[A-HJ-NP-Z0-9]{4}[A-HJ-NP-Z0-9 挂学警港澳]{1})$/),
        message: "请输入正确的车牌号格式"
      });
      break;
    //只能包含中文和数字

    case "onlyChineseAndNumber":
      basic.push({
        pattern: new RegExp(/^((?:[\u3400-\u4DB5\u4E00-\u9FEA\uFA0E\uFA0F\uFA11\uFA13\uFA14\uFA1F\uFA21\uFA23\uFA24\uFA27-\uFA29]|[\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0])|(\d))+$/),
        message: "只能包含中文和数字"
      });
      break;
    //不能包含字母

    case "noLetter":
      basic.push({
        pattern: new RegExp(/^[^A-Za-z]*$/),
        message: "不能包含字母"
      });
      break;
    //16进制颜色

    case "HexadecimalColor":
      basic.push({
        pattern: new RegExp(/^#?([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/),
        message: "请输入正确的16进制颜色格式"
      });
      break;

    default:
      basic.push({
        type: type,
        message: typeMessage
      });
      break;
  }

  return basic;
};

// `Array.prototype.{ reduce, reduceRight }` methods implementation
var createMethod = function (IS_RIGHT) {
  return function (that, callbackfn, argumentsLength, memo) {
    arrayMethodHasSpeciesSupport.aFunction(callbackfn);
    var O = _export.toObject(that);
    var self = _export.IndexedObject(O);
    var length = _export.toLength(O.length);
    var index = IS_RIGHT ? length - 1 : 0;
    var i = IS_RIGHT ? -1 : 1;
    if (argumentsLength < 2) while (true) {
      if (index in self) {
        memo = self[index];
        index += i;
        break;
      }
      index += i;
      if (IS_RIGHT ? index < 0 : length <= index) {
        throw TypeError('Reduce of empty array with no initial value');
      }
    }
    for (;IS_RIGHT ? index >= 0 : length > index; index += i) if (index in self) {
      memo = callbackfn(memo, self[index], index, O);
    }
    return memo;
  };
};

var arrayReduce = {
  // `Array.prototype.reduce` method
  // https://tc39.github.io/ecma262/#sec-array.prototype.reduce
  left: createMethod(false),
  // `Array.prototype.reduceRight` method
  // https://tc39.github.io/ecma262/#sec-array.prototype.reduceright
  right: createMethod(true)
};

var $reduce = arrayReduce.left;



var STRICT_METHOD = web_domCollections_forEach.arrayMethodIsStrict('reduce');
var USES_TO_LENGTH = arrayMethodUsesToLength.arrayMethodUsesToLength('reduce', { 1: 0 });

// `Array.prototype.reduce` method
// https://tc39.github.io/ecma262/#sec-array.prototype.reduce
_export.$({ target: 'Array', proto: true, forced: !STRICT_METHOD || !USES_TO_LENGTH }, {
  reduce: function reduce(callbackfn /* , initialValue */) {
    return $reduce(this, callbackfn, arguments.length, arguments.length > 1 ? arguments[1] : undefined);
  }
});

var max = Math.max;
var min = Math.min;
var floor = Math.floor;
var SUBSTITUTION_SYMBOLS = /\$([$&'`]|\d\d?|<[^>]*>)/g;
var SUBSTITUTION_SYMBOLS_NO_NAMED = /\$([$&'`]|\d\d?)/g;

var maybeToString = function (it) {
  return it === undefined ? it : String(it);
};

// @@replace logic
es_string_match.fixRegExpWellKnownSymbolLogic('replace', 2, function (REPLACE, nativeReplace, maybeCallNative, reason) {
  var REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE = reason.REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE;
  var REPLACE_KEEPS_$0 = reason.REPLACE_KEEPS_$0;
  var UNSAFE_SUBSTITUTE = REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE ? '$' : '$0';

  return [
    // `String.prototype.replace` method
    // https://tc39.github.io/ecma262/#sec-string.prototype.replace
    function replace(searchValue, replaceValue) {
      var O = _export.requireObjectCoercible(this);
      var replacer = searchValue == undefined ? undefined : searchValue[REPLACE];
      return replacer !== undefined
        ? replacer.call(searchValue, O, replaceValue)
        : nativeReplace.call(String(O), searchValue, replaceValue);
    },
    // `RegExp.prototype[@@replace]` method
    // https://tc39.github.io/ecma262/#sec-regexp.prototype-@@replace
    function (regexp, replaceValue) {
      if (
        (!REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE && REPLACE_KEEPS_$0) ||
        (typeof replaceValue === 'string' && replaceValue.indexOf(UNSAFE_SUBSTITUTE) === -1)
      ) {
        var res = maybeCallNative(nativeReplace, regexp, this, replaceValue);
        if (res.done) return res.value;
      }

      var rx = _export.anObject(regexp);
      var S = String(this);

      var functionalReplace = typeof replaceValue === 'function';
      if (!functionalReplace) replaceValue = String(replaceValue);

      var global = rx.global;
      if (global) {
        var fullUnicode = rx.unicode;
        rx.lastIndex = 0;
      }
      var results = [];
      while (true) {
        var result = es_string_match.regExpExec(rx, S);
        if (result === null) break;

        results.push(result);
        if (!global) break;

        var matchStr = String(result[0]);
        if (matchStr === '') rx.lastIndex = es_string_match.advanceStringIndex(S, _export.toLength(rx.lastIndex), fullUnicode);
      }

      var accumulatedResult = '';
      var nextSourcePosition = 0;
      for (var i = 0; i < results.length; i++) {
        result = results[i];

        var matched = String(result[0]);
        var position = max(min(_export.toInteger(result.index), S.length), 0);
        var captures = [];
        // NOTE: This is equivalent to
        //   captures = result.slice(1).map(maybeToString)
        // but for some reason `nativeSlice.call(result, 1, result.length)` (called in
        // the slice polyfill when slicing native arrays) "doesn't work" in safari 9 and
        // causes a crash (https://pastebin.com/N21QzeQA) when trying to debug it.
        for (var j = 1; j < result.length; j++) captures.push(maybeToString(result[j]));
        var namedCaptures = result.groups;
        if (functionalReplace) {
          var replacerArgs = [matched].concat(captures, position, S);
          if (namedCaptures !== undefined) replacerArgs.push(namedCaptures);
          var replacement = String(replaceValue.apply(undefined, replacerArgs));
        } else {
          replacement = getSubstitution(matched, S, position, captures, namedCaptures, replaceValue);
        }
        if (position >= nextSourcePosition) {
          accumulatedResult += S.slice(nextSourcePosition, position) + replacement;
          nextSourcePosition = position + matched.length;
        }
      }
      return accumulatedResult + S.slice(nextSourcePosition);
    }
  ];

  // https://tc39.github.io/ecma262/#sec-getsubstitution
  function getSubstitution(matched, str, position, captures, namedCaptures, replacement) {
    var tailPos = position + matched.length;
    var m = captures.length;
    var symbols = SUBSTITUTION_SYMBOLS_NO_NAMED;
    if (namedCaptures !== undefined) {
      namedCaptures = _export.toObject(namedCaptures);
      symbols = SUBSTITUTION_SYMBOLS;
    }
    return nativeReplace.call(replacement, symbols, function (match, ch) {
      var capture;
      switch (ch.charAt(0)) {
        case '$': return '$';
        case '&': return matched;
        case '`': return str.slice(0, position);
        case "'": return str.slice(tailPos);
        case '<':
          capture = namedCaptures[ch.slice(1, -1)];
          break;
        default: // \d\d?
          var n = +ch;
          if (n === 0) return match;
          if (n > m) {
            var f = floor(n / 10);
            if (f === 0) return match;
            if (f <= m) return captures[f - 1] === undefined ? ch.charAt(1) : captures[f - 1] + ch.charAt(1);
            return match;
          }
          capture = captures[n - 1];
      }
      return capture === undefined ? '' : capture;
    });
  }
});

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

//解析配置 确定是否需要绑定函数
//传入的参数（@arg）可能是方法或者字符串等数据
//传入函数直接返回
//传入bind:开头则取method中的方法
//传入其他格式直接返回
//传入的字符串不是 bind: 开头将包装为一个方法直接返回 ()=>arg
//(fn | fnName | otherData)=>fn
//内置一些方法
var _fns = {
  _blocksAddends: function _blocksAddends(val, props, bindParams) {
    var arr = props.form.getFieldValue(bindParams[0]);
    var totalMoney = props.form.getFieldValue(bindParams[2]);
    var sum = arr.reduce(function (prve, curBlockVal) {
      return prve += curBlockVal[bindParams[1]];
    }, 0);

    if (sum !== totalMoney) {
      var fieldArr = bindParams[2].split('.');

      if (fieldArr.length === 1) {
        props.fns.setValues(_defineProperty({}, fieldArr[0], sum));
      } else if (fieldArr.length === 2) {
        props.fns.setValues(_defineProperty({}, fieldArr[0], _defineProperty({}, fieldArr[1], sum)));
      } else {
        console.error('_blocksAddends的目标参数暂不支持三层嵌套');
      }
    }
  }
};

var bind = function bind(arg) {
  var method = _objectSpread({}, _fns, {}, this.props.method, {}, this.props.methods);

  if (typeof arg === 'function') {
    return arg;
  } else if (typeof arg === "string") {
    //如果没有 bind: 则直接返回即可 
    if (arg.indexOf("bind:") !== 0) {
      //返回为一个方法的好处是bind方法执行后肯定会继续执行来获取方法返回的值 如果返回字符串会导致把字符串当初方法执行而报错
      return function () {
        return arg;
      };
    } //取对应方法返回


    var delBindStrEd = arg.replace("bind:", ''); //获取参数和方法名

    var medAndParams = delBindStrEd.split('::');
    var methodName = medAndParams[0];
    var params = medAndParams.splice(1, medAndParams.length - 1);
    !method[methodName] && console.error("".concat(methodName, "\u672A\u5728method\u4E2D\u5B9A\u4E49\u3002"));

    if (method[methodName] && typeof method[methodName] !== "function") {
      console.error("".concat(methodName, "\u4E0D\u662F\u4E00\u4E2A\u51FD\u6570\uFF0C\u8BF7\u52FF\u5728method\u4E2D\u5B9A\u4E49\u975E\u51FD\u6570\u6570\u636E\u3002"));
    }

    return function () {
      var _method$methodName;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return (_method$methodName = method[methodName]) === null || _method$methodName === void 0 ? void 0 : _method$methodName.call.apply(_method$methodName, [method].concat(args, [params]));
    };
  } else {
    //有别的情况 所以不执行处理
    return function () {
      return arg;
    };
  }
};

//可传入ReactDom、组件名、htmlString和函数组件 调用<BindComKey {...props}>{component}</BindComKey>
// BindComKey:(ReactDom|组件名|string|函数组件)=>ReactDom

var BindComKey = function BindComKey(props) {
  var ComponentsKey = props.componentsKey;
  var children = props.children; //直接写到配置里面的类组件

  if (React__default.isValidElement(children)) {
    var Children = children;
    return React__default.cloneElement(Children);
  } else {
    if (typeof children === "function") {
      //直接写到配置里面的函数组件
      return children(props);
    } else if (ComponentsKey[children]) {
      //是写到componentsKey中的自定义组件
      //类组件
      if (React__default.isValidElement(ComponentsKey[children])) {
        var _Children = ComponentsKey[children];
        return React__default.cloneElement(_Children);
      } else if (typeof ComponentsKey[children] === "function") {
        //直接写到配置里面的函数组件 
        return ComponentsKey[children](props);
      } else {
        return ComponentsKey[children];
      }
    } else {
      if (!children) {
        // console.warn(`配置中有自定义组件未在componentsKey定义！请检查，ps:icon也是用自定义组件`)
        return React__default.createElement("span", null);
      } else {
        return children;
      }
    }
  }
};

//获取消息提醒 (输入框类型， 规则)
var getMessageType = function getMessageType(type) {
  switch (type) {
    case 'string':
      return "\u8BF7\u586B\u5199\u5B57\u7B26\u4E32";

    case 'email':
      return "\u8BF7\u586B\u5199\u90AE\u7BB1";

    case 'url':
      return "\u8BF7\u586B\u5199\u7F51\u5740";

    case 'number':
      return "\u8BF7\u586B\u5199\u6570\u5B57";

    case 'integer':
      return "\u8BF7\u586B\u5199\u6574\u6570";

    case 'date':
      return "\u8BF7\u586B\u5199\u65E5\u671F";

    case 'regexp':
      return "\u8BF7\u586B\u5199\u6B63\u5219";

    default:
      return '未知类型';
  }
};

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty$1(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getInitialValues = function getInitialValues(_ref) {
  var _ref$formConfig = _ref.formConfig,
      formConfig = _ref$formConfig === void 0 ? [] : _ref$formConfig,
      _ref$tabs = _ref.tabs,
      tabs = _ref$tabs === void 0 ? [] : _ref$tabs,
      _ref$fns = _ref.fns,
      tool = _ref$fns.tool,
      bind = _ref$fns.bind,
      funcCallBackParams = _ref.funcCallBackParams,
      qnnformData = _ref.qnnformData,
      params = _ref.qnnformData.match.params;
  //默认值从initialValues 有相同的则覆盖
  var copyInitialValue = immutable.fromJS(qnnformData.initialValues || {}).toJS(); //保证所有field都是数组

  var allFieldConfig = tool.getAllFormBlockField(tool.getAllFormField({
    formConfig: formConfig,
    tabs: tabs
  })).map(function (item) {
    if (item.field && !Array.isArray(item.field)) {
      var _item$field;

      item.field = (_item$field = item.field) === null || _item$field === void 0 ? void 0 : _item$field.split('.');
    }

    return item;
  }).filter(function (item) {
    return item.field;
  }); //没有field配置全部过滤掉 
  //1、copyInitialValue是一个对象 里面值优先取用
  //2、每个字段都可能会有initialValue  当copyInitialValue没有该字段值时 需要取用该字段的initialValue

  var initialValues = allFieldConfig.reduce(function (prveVals, curFieldConfig) {
    var field = curFieldConfig.field,
        initialValue = curFieldConfig.initialValue,
        type = curFieldConfig.type,
        canAddForm = curFieldConfig.canAddForm,
        isUrlParams = curFieldConfig.isUrlParams;

    if (!field) {
      console.error("\u914D\u7F6E\u9519\u8BEF\uFF1A\u7F3A\u5C11 field \u914D\u7F6E \n", JSON.stringify(curFieldConfig, null, 4));
    }

    var len = field.length - 1;
    field.reduce(function (prev, cur, index) {
      if (len === index && !Array.isArray(prev)) {
        //设置值
        var _v = isUrlParams ? params[field] : prev[cur] || bind(initialValue)(_objectSpread$1({}, funcCallBackParams()));

        if (type === "qnnForm" && canAddForm && !_v) {
          prev[cur] = [];
        } else {
          prev[cur] = _v;
        }
      } else if (!prev[cur] && !Array.isArray(prev)) {
        //继续设置默认值 
        prev[cur] = {};
      }

      return prev[cur];
    }, prveVals);
    return prveVals;
  }, copyInitialValue); // console.log(allFieldConfig, initialValues)

  var formated = _objectSpread$1({}, tool.formatData(initialValues, tool.getAllFormField({
    tabs: tabs,
    formConfig: formConfig
  }).filter(function (item) {
    return item.field;
  }), "set"));

  return formated;
};

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { _defineProperty$2(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$2(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//除非有特殊的一些请求什么的比较复杂的需要写方法执行的属性配置不用写到这个文件，其余的都在这里配置
//所有共通的input输入框的props 
var getInputProps = function getInputProps(props) {
  var _onChange = props.onChange,
      value = props.value,
      checked = props.checked,
      fieldConfig = props.fieldConfig,
      _props$fieldConfig = props.fieldConfig,
      type = _props$fieldConfig.type,
      field = _props$fieldConfig.field,
      placeholder = _props$fieldConfig.placeholder,
      multiple = _props$fieldConfig.multiple,
      showSearch = _props$fieldConfig.showSearch,
      _props$fieldConfig$op = _props$fieldConfig.optionConfig,
      optionConfig = _props$fieldConfig$op === void 0 ? {} : _props$fieldConfig$op,
      disabled = _props$fieldConfig.disabled,
      hide = _props$fieldConfig.hide,
      className = _props$fieldConfig.className,
      optionDataGroup = _props$fieldConfig.optionDataGroup,
      isUrlParams = _props$fieldConfig.isUrlParams,
      fetchConfig = _props$fieldConfig.fetchConfig,
      optionData = _props$fieldConfig.optionData,
      dependencies = _props$fieldConfig.dependencies,
      help = _props$fieldConfig.help,
      labelClick = _props$fieldConfig.labelClick,
      labelCanClick = _props$fieldConfig.labelCanClick,
      condition = _props$fieldConfig.condition,
      parent = _props$fieldConfig.parent,
      initialValue = _props$fieldConfig.initialValue,
      oldValue = _props$fieldConfig.oldValue,
      oldValueKey = _props$fieldConfig.oldValueKey,
      formItemStyle = _props$fieldConfig.formItemStyle,
      colStyle = _props$fieldConfig.colStyle,
      voice = _props$fieldConfig.voice,
      locInfo = _props$fieldConfig.locInfo,
      picker = _props$fieldConfig.picker,
      diyRules = _props$fieldConfig.diyRules,
      noStyle = _props$fieldConfig.noStyle,
      pushJoin = _props$fieldConfig.pushJoin,
      pullJoin = _props$fieldConfig.pullJoin,
      formItemLayout = _props$fieldConfig.formItemLayout,
      qnnTableConfig = _props$fieldConfig.qnnTableConfig,
      labelStyle = _props$fieldConfig.labelStyle,
      formatter = _props$fieldConfig.formatter,
      parser = _props$fieldConfig.parser,
      addShow = _props$fieldConfig.addShow,
      addDisabled = _props$fieldConfig.addDisabled,
      qnnDisabled = _props$fieldConfig.qnnDisabled,
      editShow = _props$fieldConfig.editShow,
      editDisabled = _props$fieldConfig.editDisabled,
      formItemLayoutForm = _props$fieldConfig.formItemLayoutForm,
      otherConfig = _objectWithoutProperties(_props$fieldConfig, ["type", "field", "placeholder", "multiple", "showSearch", "optionConfig", "disabled", "hide", "className", "optionDataGroup", "isUrlParams", "fetchConfig", "optionData", "dependencies", "help", "labelClick", "labelCanClick", "condition", "parent", "initialValue", "oldValue", "oldValueKey", "formItemStyle", "colStyle", "voice", "locInfo", "picker", "diyRules", "noStyle", "pushJoin", "pullJoin", "formItemLayout", "qnnTableConfig", "labelStyle", "formatter", "parser", "addShow", "addDisabled", "qnnDisabled", "editShow", "editDisabled", "formItemLayoutForm"]),
      form = props.form,
      _props$qnnformData = props.qnnformData,
      _props$qnnformData$fo = _props$qnnformData.formConfig,
      formConfig = _props$qnnformData$fo === void 0 ? [] : _props$qnnformData$fo,
      style = _props$qnnformData.style,
      headers = _props$qnnformData.headers,
      _props$fns = props.fns,
      bind = _props$fns.bind,
      loopClearChild = _props$fns.loopClearChild,
      fetch = _props$fns.fetch,
      setSelectOptionFns = props.setSelectOptionFns,
      id = props.id,
      funcCallBackParams = props.funcCallBackParams; //格式化值


  var formatVal = value;

  if ((type !== "number" || type !== "integer") && formatter) {
    formatVal = bind(formatter)(props.value, funcCallBackParams);
  } //所有输入input都有的props


  var inputBaisePorpsData = _objectSpread$2({}, otherConfig, {
    picker: picker,
    field: field,
    //需要的
    value: formatVal,
    checked: checked,
    style: _objectSpread$2({
      width: "100%",
      display: hide ? "none" : ""
    }, fieldConfig.style),
    className: "".concat(className, " ").concat(style.qnnFormInput, " qnnFormInput ").concat(voice ? style.voice : ""),
    id: id,
    disabled: disabled,
    //这块必须在具体的输入组件中将值转换传入进来 还需将输入组件或者组件的其他信息信息传入
    //这个change方法在执行前是在输入控件里面被修改过
    onChange: function onChange(val) {
      var _bind;

      var changeProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      //下拉特有的双向字段数据绑定
      var linkageFields = optionConfig.linkageFields,
          children = optionConfig.children; //多选时候第二个参数为itemData

      var itemData = multiple ? changeProps.map(function (item) {
        return item.itemdata;
      }) : changeProps.itemdata || changeProps.itemData;
      var itemParentData = multiple ? changeProps.map(function (item) {
        return item.parentdata;
      }) : changeProps.parentdata;

      if (linkageFields) {
        var vals = {};

        for (var targetField in linkageFields) {
          //字段可能是表单块中的字段，所有需要额外判断
          var optionKey = linkageFields[targetField];
          var targetFieldArr = targetField.split(".");

          if (targetFieldArr.length > 1) {
            //表单块字段
            //暂时只支持非可增减表单块联动 
            //就是把 aaa.bbb才分为 [aaa, bbb]然后格式化为 aaa:{bbb:value}
            if (!vals[targetFieldArr[0]]) {
              vals[targetFieldArr[0]] = {};
            }
            vals[targetFieldArr[0]][targetFieldArr[1]] = itemData[optionKey];
          } else {
            vals[targetField] = itemData[optionKey];
          }
        }

        form.setFieldsValue(vals);
      } //是否是个联动字段
      //是联动字段在切换值时候需要寻找子字段，并且给子字段设置下拉选项


      var childFieldByInFormBlock; //用于储存下拉值的key使用 

      var blockField; //如果子集在表单块中，那就需要在把子集field给到该变量

      var blockChildField; //寻找子字段（如果子字段存在那肯定就是联动成员，这个过程中主要就是关注表单块的联动）
      //是否是子字段，成立的条件是子字段所配置的parent属性，是否等于该字段的field  
      //普通表单拿取联动
      //遇到表单块时并且表单块中某字段满足条件时，直接使用满足条件的字段即可

      var childField = formConfig.filter(function (item) {
        var formFields = item.formFields,
            type = item.type,
            _item$qnnFormConfig = item.qnnFormConfig,
            qnnFormConfig = _item$qnnFormConfig === void 0 ? {} : _item$qnnFormConfig;

        if (type === "qnnForm") {
          //兼容写法(不建议写qnnFormConfig，推荐使用formFields)
          var qnnFormConfig_formConfig = qnnFormConfig.formConfig;
          var fields = formFields ? formFields : qnnFormConfig_formConfig;
          childFieldByInFormBlock = fields.filter(function (childFieldCon) {
            return childFieldCon.parent === (Array.isArray(field) ? field.join('.') : field);
          })[0]; //拿到表单块的 块id

          if (childFieldByInFormBlock) {
            blockField = item.field;
            blockChildField = childFieldByInFormBlock.field;
          }
        } //field可能是个数组，因为在表单块里的字段field都是数组 是数组的话需要用逗号拼接下


        return item.parent === (Array.isArray(field) ? field.join('.') : field) || childFieldByInFormBlock;
      })[0];

      if (childField) {
        //可能是表单块中的字段，所以需要注意字段可能是个数组的情况
        var _fieldConfig = childFieldByInFormBlock || childField; //blockChildField存在的话就直接用blockChildField即可，因为在表单块中的子集属于特殊情况


        var realField = blockField ? "".concat(blockField, ".").concat(blockChildField ? blockChildField : _fieldConfig.field) : _fieldConfig.field; //如果【child字段】是下拉字段，还需要将该字段的下拉选项中的[children]数据，给到 【child字段】 做下拉选项使用 
        //清空子字段值并且设置子字段下拉选项   

        loopClearChild(Array.isArray(realField) ? realField : realField.split('.'));
        setSelectOptionFns(Array.isArray(realField) ? realField.join('.') : realField, itemData === null || itemData === void 0 ? void 0 : itemData[children]);
      } //props.onChange是字段的onChange必须调用才能给字段设置值  
      //props.fieldConfig.onChange 是配置中的监听change
      //每个组件都必须调用props中的onChange来操作值因为Form.Item只对直接子元素生效，这里需要做异步加载组件。所以有些冲突


      _onChange(val);

      (_bind = bind(props.fieldConfig.onChange)) === null || _bind === void 0 ? void 0 : _bind(val, _objectSpread$2({}, changeProps, {}, props, {
        itemData: itemData,
        itemParentData: itemParentData
      }));
    }
  }); //初始值给空字符串也不给placeholder


  var _placeholder = placeholder;

  if (placeholder === "" || placeholder === '' || placeholder === null || placeholder === false || initialValue === '' || initialValue === "") {
    _placeholder = " "; //空的
  } //不同控件的props


  var inputOtherPorpsData = {
    placeholder: _placeholder ? _placeholder : "请输入..."
  }; //根据不同控件做些特殊处理

  switch (type) {
    case "select":
    case "selectByPaging":
      inputOtherPorpsData = _objectSpread$2({}, inputOtherPorpsData, {
        allowClear: true,
        showSearch: type === "selectByPaging" ? true : showSearch,
        mode: multiple ? "multiple" : null,
        optionFilterProp: "children",
        placeholder: _placeholder ? _placeholder : "请选择..."
      });
      break;

    case "cascader":
      inputOtherPorpsData = _objectSpread$2({}, inputOtherPorpsData, {
        showSearch: showSearch,
        allowClear: true,
        placeholder: _placeholder ? _placeholder : "请选择..."
      });
      break;

    case "qnnTable":
      if (!qnnTableConfig.antd) {
        qnnTableConfig.antd = {
          size: "small"
        };
      }

      inputOtherPorpsData = _objectSpread$2({
        headers: headers,
        fetch: fetch,
        actionBtnsPosition: "bottom"
      }, qnnTableConfig, {
        qnnFormProps: _objectSpread$2({}, props),
        antd: _objectSpread$2({
          size: "small"
        }, qnnTableConfig.antd)
      });
      break;

    case "date":
    case "datetime":
    case "month":
    case "year":
    case "time":
    case "week":
      inputOtherPorpsData = _objectSpread$2({}, inputOtherPorpsData, {
        placeholder: _placeholder ? _placeholder : "请选择..."
      });
      break;

    case "rangeDate":
      //placeholder自动分配
      var tObj = {
        date: "日期",
        time: "时间",
        week: "周",
        year: "年份",
        month: "月份"
      };
      var t = tObj[picker] ? tObj[picker] : tObj.date;
      inputOtherPorpsData = _objectSpread$2({}, inputOtherPorpsData, {
        placeholder: Array.isArray(_placeholder) ? _placeholder : ["\u5F00\u59CB".concat(t), "\u7ED3\u675F".concat(t)]
      });
      break;

    case "money":
      inputOtherPorpsData.formatter = function (value) {
        return "".concat(value).replace(/\B(?=(\d{3})+(?!\d))/g, ',');
      };

      inputOtherPorpsData.parser = function (value) {
        return value.replace(/\$\s?|(,*)/g, '');
      };

      break;

    case "integer":
    case "number":
      inputOtherPorpsData.formatter = formatter;
      inputOtherPorpsData.parser = parser;
      break;

    default:
      inputOtherPorpsData = _objectSpread$2({}, inputOtherPorpsData);
      break;
  } //用户传入的配置会覆盖掉根据不同控件做的特殊处理配置


  var realInputProps = _objectSpread$2({}, inputOtherPorpsData, {}, inputBaisePorpsData); //禁用的输入控件不能显示placeholder


  if (disabled) {
    realInputProps.placeholder = undefined;
  }

  return realInputProps;
};

// @str [string] eg "{{label}} => {{ext1}}"
//(@str)=>[匹配上的所有字段]
var getStrTmp = function getStrTmp(str) {
  if (typeof str === "string") {
    var exg = /(\{\{)(\w+)(\}\})/ig;
    return str.match(exg);
  } else {
    return str;
  }
};

//传入字段名字 执行清空该字段的值和该字段所有子级的值
//@field  Array|string
var loopClearChild = function loopClearChild(field) {
  var form = this.form,
      state = this.state;
  var formConfig = state.formConfig; //请求该字段值 

  form.resetFields([field]); //循环匹配普通表的所有字段

  for (var i = 0; i < formConfig.length; i++) {
    var formConfigItem = formConfig[i]; //普通表单

    if (formConfigItem.parent === field.join('.')) {
      var _formConfigItem$field;

      //需要清空改字段的值
      loopClearChild.bind(this)((_formConfigItem$field = formConfigItem.field) === null || _formConfigItem$field === void 0 ? void 0 : _formConfigItem$field.split('.'));
    } //表单块表单


    if (formConfigItem.type === "qnnForm") {
      //兼容写法(不建议写qnnFormConfig，推荐使用formFields) 
      var _fields = formConfigItem.formFields ? formConfigItem.formFields : formConfigItem.qnnFormConfig.formConfig; //再次循环匹配表单块内所有子字段


      for (var _i = 0; _i < _fields.length; _i++) {
        var _formConfigItem = _fields[_i]; //普通表单

        if (_formConfigItem.parent === field.join('.')) {
          //需要清空改字段的值
          //注意这块是表单块的，需要拼上表单的field
          loopClearChild.bind(this)([formConfigItem.field, _formConfigItem.field]);
        }
      }
    }
  }
};

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { _defineProperty$3(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$3(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var isMobile = function isMobile() {
  return getDeviceType() === "mobile";
};

var tool = {
  //确认弹窗
  confirm: function confirm() {
    var title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "确认提交吗？";
    var content = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "如确认信息无误请点击[确认]按钮继续提交。";
    var onOk = arguments.length > 2 ? arguments[2] : undefined;
    var yes = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '确认';
    var no = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : '取消';

    if (isMobile()) {
      _Modal.alert(title, content, [{
        text: no,
        onPress: function onPress() {}
      }, {
        text: yes,
        onPress: onOk
      }]);
    } else {
      _Modal2.confirm({
        title: title,
        content: content,
        okText: yes,
        cancelText: no,
        onOk: onOk
      });
    }
  },
  //如果tabs是配置不存在将直接return formConfig
  //将tabs中的所有tab页是qnnForm的formConfig字段合并到一个数组中return出去
  //onlyFormatValue 为仅仅只是取值时候格式化
  getAllFormField: function getAllFormField(_ref) {
    var _ref$tabs = _ref.tabs,
        tabs = _ref$tabs === void 0 ? [] : _ref$tabs,
        _ref$formConfig = _ref.formConfig,
        formConfig = _ref$formConfig === void 0 ? [] : _ref$formConfig,
        onlyFormatValue = _ref.onlyFormatValue;
    var formFields = formConfig; //1、将tabs情况下各个qnnForm类型的表单字段集合

    if (tabs.length) {
      var _ref2;

      formFields = (_ref2 = []).concat.apply(_ref2, _toConsumableArray(tabs.filter(function (item) {
        return item.name === "qnnForm" || item.type === "qnnForm";
      }).map(function (item) {
        return item.content.formConfig;
      })));
    } //1-1、描述式表单 需要将children提取出来
    //先格式化为二维数组 然后进行合并  需要注意自己field


    if (onlyFormatValue) {
      formFields = formFields.map(function (item) {
        var arrE = [item];

        if (item.children && item.children.formConfig) {
          item.children.formConfig.forEach(function (childItem) {
            arrE.push(_objectSpread$3({}, childItem, {
              field: "".concat(item.field, ".").concat(childItem.field)
            }));
          });
        }

        return arrE;
      }).reduce(function (prve, curItem) {
        return prve.concat(curItem);
      }, []);
    } //2、兼容linkage类型的字段


    var linkageFields = [];

    var loopLikage = function loopLikage(config, commConfig, parentField) {
      var _config$form;

      linkageFields.push(_objectSpread$3({
        parent: parentField
      }, commConfig, {}, config.form, {
        fetchConfig: parentField ? config.form.fetchConfig : commConfig.fetchConfig,
        children: null
      }));
      (config === null || config === void 0 ? void 0 : config.children) && loopLikage(config.children, commConfig, (_config$form = config.form) === null || _config$form === void 0 ? void 0 : _config$form.field);
      return linkageFields;
    };

    formFields = formFields.map(function (item) {
      if (item.type === "linkage") {
        linkageFields = []; //清空

        loopLikage(item.children, item);
        item = linkageFields;
      }

      return item;
    }).reduce(function (prev, cur) {
      return prev.concat(cur);
    }, []);
    return formFields;
  },
  //传入formConfig将所有字段类型为qnnForm类型的字段配置在提取出来（并且处理好父子级字段名）
  //就是将嵌套的表单块中的配置字段全部提取出来方便后期遍历
  getAllFormBlockField: function getAllFormBlockField() {
    var _ref3;

    var formConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    //将所有字段类型为qnnForm的表单每个字段提出取出来方便使用
    return (_ref3 = _toConsumableArray(formConfig)).concat.apply(_ref3, _toConsumableArray(formConfig.filter(function (item) {
      return item.type === "qnnForm";
    }).map(function (item) {
      var _item$qnnFormConfig;

      return (item.formFields ? item.formFields : (_item$qnnFormConfig = item.qnnFormConfig) === null || _item$qnnFormConfig === void 0 ? void 0 : _item$qnnFormConfig.formConfig).map(function (_config) {
        return _objectSpread$3({}, _config, {
          field: "".concat(item.field, ".").concat(_config.field)
        });
      });
    })));
  },
  //传入字段名和tabs数据返回字段所处的tabs索引
  //主要对于判断表单块中的字段在哪个tab页面非常有用
  getFieldCurTabIndex: function getFieldCurTabIndex(field) {
    var tabs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var index = 0;

    for (var i = 0; i < tabs.length; i++) {
      var tabItem = tabs[i];

      if (tabItem.name === 'qnnForm' || tabItem.type === 'qnnForm') {
        for (var j = 0; j < tabItem.content.formConfig.length; j++) {
          var tabsContentFormConfigItem = tabItem.content.formConfig[j];

          if (tabsContentFormConfigItem.field === field.split('.')[0]) {
            index = i;
          }
        }
      }
    }

    return index;
  },
  //获取根据field获取field信息
  //(...)=>{fieldConfig, tabIndex(字段所在的tab页面)}
  getFieldConfig: function getFieldConfig(field, _ref4) {
    var _ref4$tabs = _ref4.tabs,
        tabs = _ref4$tabs === void 0 ? [] : _ref4$tabs,
        _ref4$formConfig = _ref4.formConfig,
        formConfig = _ref4$formConfig === void 0 ? [] : _ref4$formConfig;
    field = Array.isArray(field) ? field.join('.') : field; //将所有表单类型的tab聚合到一个数组

    var fc = tabs.length ? tool.getAllFormField({
      tabs: _toConsumableArray(tabs)
    }) : formConfig; //将所有字段类型为qnnForm的表单每个字段提出取出来方便使用

    var fc_block = tool.getAllFormBlockField(fc); //合并所有字段数据并且过滤出需要的字段

    var targetFieldConfig = _toConsumableArray(fc_block).filter(function (item) {
      var _itemField = Array.isArray(item.field) ? item.field.join('.') : item.field;

      return _itemField === field;
    })[0]; //获取字段所处的tab位置


    var index = tool.getFieldCurTabIndex(targetFieldConfig.field, tabs);
    return {
      fieldConfig: targetFieldConfig,
      tabIndex: index
    };
  },
  //根据field获取 数据中的属性值
  //field可为 . 号连接的属性地址 eg apiBody.name
  //@path string  
  //@data object
  getDataValByField: function getDataValByField(path, data) {
    var _path$split;

    if (!path) {
      console.error("未读取到field配置！！请检查  ---getDataValByField方法提示");
    }

    var arr = ((_path$split = path.split) === null || _path$split === void 0 ? void 0 : _path$split.call(path, '.')) || path;
    var len = arr.length - 1;
    var val = null;
    arr.reduce(function (prev, cur, index) {
      if (index === len) {
        val = prev[cur];
      }

      return (prev === null || prev === void 0 ? void 0 : prev[cur]) || {};
    }, data);
    return val;
  },
  //格式化数据
  //格式化数据需要格式化嵌套值的情况 eg: a.b 的值是 a:{b:xx}
  formatData: function formatData(values) {
    var formConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "set";
    //从格式化数据中取值和设置值必须走代理
    var formatedData = new Proxy({}, {
      //key如果是个数组的话，传入后将自动被使用逗号连接
      set: function set(target, key, value) {
        //使用逗号拆分然后使用.号拆分最后连接
        var fieldArr = key.split(',').map(function (item) {
          return item.split('.');
        }).reduce(function (prve, cur) {
          return prve.concat(cur);
        }, []);

        if (fieldArr.length > 1) {
          var len = fieldArr.length - 1;
          fieldArr.reduce(function (prev, cur, index) {
            if (len === index) {
              //设置值
              prev[cur] = value;
            } else if (!prev[cur]) {
              //继续设置默认值
              prev[cur] = {};
            }

            return prev[cur];
          }, target);
        } else {
          target[key] = value;
        }

        return true;
      }
    });

    if (type === "get") {
      formConfig.forEach(function (fieldConfig) {
        var type = fieldConfig.type,
            field = fieldConfig.field,
            scope = fieldConfig.scope,
            _fieldConfig$pushJoin = fieldConfig.pushJoin,
            pushJoin = _fieldConfig$pushJoin === void 0 ? true : _fieldConfig$pushJoin,
            _fieldConfig$qnnFormC = fieldConfig.qnnFormConfig,
            qnnFormConfig = _fieldConfig$qnnFormC === void 0 ? {} : _fieldConfig$qnnFormC,
            formFields = fieldConfig.formFields,
            canAddForm = fieldConfig.canAddForm,
            multiple = fieldConfig.multiple,
            ov = fieldConfig.ov,
            cv = fieldConfig.cv;
        formFields = formFields || qnnFormConfig.formConfig; //兼容写法

        var itemValue = tool.getDataValByField(field, values); //其他情况则正常获取值即可
        //当值存在是进行操作 否则忽略  0和false别忽略

        if (itemValue || itemValue === 0 || itemValue === false) {
          switch (type) {
            case "qnnForm":
              if (canAddForm) {
                formatedData[field] = itemValue.map(function (item) {
                  return tool.formatData(item, formFields, "get");
                });
              } else {
                formatedData[field] = tool.formatData(itemValue, formFields, "get");
              }

              break;

            case "date":
            case "time":
            case "datetime":
            case "month":
            case "year":
            case "week":
              if (scope) {
                formatedData[field] = {
                  value: itemValue.value ? moment(itemValue.value).valueOf() : itemValue.value,
                  scope: itemValue.scope
                };
              } else {
                formatedData[field] = moment(itemValue).valueOf();
              }

              break;

            case "rangeDate":
              formatedData[field] = [moment(itemValue[0]).valueOf(), moment(itemValue[1]).valueOf()];
              break;
            //可能会将值用逗号连接的配置

            case "cascader":
            case "item":
            case "checkbox":
              formatedData[field] = pushJoin && Array.isArray(itemValue) ? itemValue.join(',') : itemValue;
              break;

            case "select":
            case "selectByPaging":
              formatedData[field] = pushJoin && multiple ? itemValue.join(',') : itemValue;
              break;

            case "switch":
              formatedData[field] = itemValue === true ? ov || itemValue : cv || itemValue;
              break;

            default:
              formatedData[field] = itemValue;
              break;
          }
        } else {
          //空的值也不能忽略 否则字段将不可以删除了
          formatedData[field] = itemValue;
        }
      });
      return _objectSpread$3({}, formatedData);
    } else {
      //获取设置进表单的格式化值 
      formConfig.forEach(function (fieldConfig) {
        if (!fieldConfig) {
          console.warn("字段配置为空！！！请检查");
          return;
        }

        var type = fieldConfig.type,
            field = fieldConfig.field,
            _fieldConfig$pullJoin = fieldConfig.pullJoin,
            pullJoin = _fieldConfig$pullJoin === void 0 ? true : _fieldConfig$pullJoin,
            _fieldConfig$qnnFormC2 = fieldConfig.qnnFormConfig,
            qnnFormConfig = _fieldConfig$qnnFormC2 === void 0 ? {} : _fieldConfig$qnnFormC2,
            formFields = fieldConfig.formFields,
            canAddForm = fieldConfig.canAddForm,
            multiple = fieldConfig.multiple,
            scope = fieldConfig.scope,
            ov = fieldConfig.ov;
        formFields = formFields || qnnFormConfig.formConfig; //兼容写法
        //field可能是个嵌套  

        var itemValue = tool.getDataValByField(field, values); //当值存在是进行操作 否则忽略  0和false别忽略
        //等于 undefind 的就不要进行操作了 否则会把所有表单字段都给清空了

        if (itemValue || itemValue === 0 || itemValue === false || itemValue === null || itemValue === "") {
          switch (type) {
            case "qnnForm":
              if (canAddForm) {
                var _itemValue$map;

                formatedData[field] = itemValue === null || itemValue === void 0 ? void 0 : (_itemValue$map = itemValue.map) === null || _itemValue$map === void 0 ? void 0 : _itemValue$map.call(itemValue, function (item) {
                  return tool.formatData(item, formFields, "set");
                });
              } else {
                formatedData[field] = tool.formatData(itemValue, formFields, "set");
              }

              break;

            case "date":
            case "time":
            case "datetime":
            case "month":
            case "year":
              if (scope) {
                formatedData[field] = isMobile() ? _objectSpread$3({}, itemValue, {
                  value: new Date(itemValue.value)
                }) : _objectSpread$3({}, itemValue, {
                  value: moment(itemValue.value)
                });
              } else {
                formatedData[field] = isMobile() ? new Date(itemValue) : moment(itemValue);
              }

              break;
            //周组件使用的pc端组件

            case "week":
              if (scope) {
                formatedData[field] = _objectSpread$3({}, itemValue, {
                  value: moment(itemValue.value)
                });
              } else {
                formatedData[field] = moment(itemValue);
              }

              break;

            case "rangeDate":
              formatedData[field] = [moment(itemValue[0]), moment(itemValue[1])];
              break;
            //可能会将值用逗号连接的配置

            case "cascader":
            case "item":
            case "checkbox":
              formatedData[field] = pullJoin && Array.isArray(itemValue) ? itemValue : itemValue === null || itemValue === void 0 ? void 0 : itemValue.split(',');
              break;

            case "select":
            case "selectByPaging":
              formatedData[field] = pullJoin && multiple ? itemValue === null || itemValue === void 0 ? void 0 : itemValue.split(',') : itemValue;
              break;

            case "switch":
              if (ov) {
                formatedData[field] = itemValue === ov ? true : false;
              } else {
                formatedData[field] = itemValue;
              }

              break;

            case "files":
            case "upload":
            case "camera":
            case "filesDragger":
            case "images":
              if (isMobile()) {
                formatedData[field] = itemValue.map(function (item, index) {
                  var mobileUrl = item.mobileUrl,
                      name = item.name,
                      fileUrl = item.fileUrl,
                      fileName = item.fileName,
                      url = item.url;
                  return _objectSpread$3({}, item, {
                    url: mobileUrl || fileUrl || url,
                    name: name || fileName,
                    uid: index
                  });
                });
              } else {
                formatedData[field] = itemValue.map(function (item, index) {
                  var url = item.url,
                      name = item.name,
                      fileUrl = item.fileUrl,
                      fileName = item.fileName,
                      thumbUrl = item.thumbUrl;

                  if (type === "images") {
                    url = thumbUrl || url;
                  }

                  return _objectSpread$3({}, item, {
                    type: "",
                    status: 'done',
                    url: url || fileUrl,
                    name: name || fileName,
                    uid: index
                  });
                });
              }

              break;

            default:
              formatedData[field] = itemValue;
              break;
          }
        }
      });
      return _objectSpread$3({}, formatedData);
    }
  },
  //删除不需要的提交参数
  //@val 表单数据
  //@delParams 需要删除的字段名集合
  delParams: function delParams(values, _delParams) {
    var _newParams = {};

    for (var key in values) {
      if (key) {
        var element = values[key];

        if (!_delParams.includes(key)) {
          _newParams[key] = element;
        }
      }
    }

    return _newParams;
  },
  //消息提示
  msg: function () {
    //公司居然要求全部用 ~~~ notification ~~~  i服了
    var msg = _objectSpread$3({}, _message, {
      baisc: function baisc(type, content) {
        var duration = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 3;

        _notification[type]({
          message: '系统遇到问题，请联系运维人员',
          description: "".concat(content),
          duration: duration
        });
      },
      error: function error() {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return msg.baisc.apply(msg, ['error'].concat(args));
      },
      success: function success() {
        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return msg.baisc.apply(msg, ['success'].concat(args));
      },
      warning: function warning() {
        for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
          args[_key3] = arguments[_key3];
        }

        return msg.baisc.apply(msg, ['warning'].concat(args));
      },
      warn: function warn() {
        for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }

        return msg.baisc.apply(msg, ['warn'].concat(args));
      }
    }); // 正确用法
    // const msg = { ...message };


    if (isMobile()) {
      //     msg.error = Toast.fail;
      //     msg.success = Toast.success;
      //     msg.loading = Toast.loading;
      //     msg.info = Toast.info;
      msg.destroy = _Toast.hide;
    }

    return msg;
  }(),
  //改变form对象用以兼容以前版本的
  getForm: function getForm(form) {
    var getArrayName = function getArrayName(name) {
      return Array.isArray(name) ? name : name.split('.');
    };

    return _objectSpread$3({}, form, {
      getFieldValue: function getFieldValue(name) {
        var _form$getFieldValue;

        return form === null || form === void 0 ? void 0 : (_form$getFieldValue = form.getFieldValue) === null || _form$getFieldValue === void 0 ? void 0 : _form$getFieldValue.call(form, getArrayName(name));
      },
      getFieldsValue: function getFieldsValue() {
        var _form$getFieldsValue;

        var names = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        names = names.map(function (item) {
          return getArrayName(item);
        });
        return (_form$getFieldsValue = form.getFieldsValue) === null || _form$getFieldsValue === void 0 ? void 0 : _form$getFieldsValue.call(form, names.length ? names : undefined);
      },
      getFieldError: function getFieldError(name) {
        return form.getFieldError(getArrayName(name));
      },
      getFieldsError: function getFieldsError() {
        var names = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        names = names.map(function (item) {
          return getArrayName(item);
        });
        return form.getFieldsError(names.length ? names : undefined);
      },
      resetFields: function resetFields() {
        var names = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        names = names.map(function (item) {
          return getArrayName(item);
        });
        return form.resetFields(names.length ? names : undefined);
      },
      validateFields: function validateFields() {
        var names = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        names = names.map(function (item) {
          return getArrayName(item);
        });

        for (var _len5 = arguments.length, args = new Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
          args[_key5 - 1] = arguments[_key5];
        }

        return form.validateFields.apply(form, [names.length ? names : undefined].concat(args));
      },
      validateFieldsAndScroll: function validateFieldsAndScroll(nameList, cb) {
        var names;

        if (Array.isArray(nameList)) {
          names = nameList;
        } else {
          //肯定是回调
          cb = names;
        }

        names = names.map(function (item) {
          return getArrayName(item);
        });
        form.validateFields(names).then(function (vals) {
          cb(null, vals);
        }).catch(function (errs) {
          cb(errs.errorFields, errs.values);
        });
      }
    });
  },
  //获取地址信息
  //使用wx sdk获取经纬度  使用百度地图转换为地址
  getLocAddressInfo: function getLocAddressInfo() {
    return new Promise(function (resolve) {
      var _window = window,
          wx = _window.wx;
      wx.ready(function () {
        wx.getLocation({
          type: 'wgs84',
          // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
          success: function success(res) {
            var latitude = res.latitude; // 纬度，浮点数，范围为90 ~ -90

            var longitude = res.longitude; // 经度，浮点数，范围为180 ~ -180。 

            try {
              var ggPoint = new window.BMap.Point(longitude, latitude);
              var myGeo = new window.BMap.Geocoder();

              if (ggPoint) {
                //坐标转换 
                var convertor = new window.BMap.Convertor();
                var pointArr = [];
                pointArr.push(ggPoint);
                convertor.translate(pointArr, 1, 5, function (addressData) {
                  if (addressData.status === 0) {
                    myGeo.getLocation(addressData.points[0], function (rs) {
                      var addComp = rs.addressComponents;
                      var address = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                      resolve(_objectSpread$3({}, addComp, {
                        address: address,
                        latitude: latitude,
                        longitude: longitude
                      }));
                    });
                  } else {
                    console.error('1、请检查是否引入了百度地图cdn!');
                    console.error('2、请检查百度地图地址转换额度是否已用完!');
                    console.error('百度地图方法转换经纬度为地址失败！！！');
                  }
                });
              }
            } catch (err) {
              console.error('1、请检查是否引入了百度地图cdn!');
              console.error('2、请检查百度地图地址转换额度是否已用完!');
              console.error(err);
            }
          }
        });
      });
    });
  },
  //根据fetchConfig中的params,otherParams,还有form字段和路由参数获取请求参数
  getFetchParams: function getFetchParams(_ref5) {
    var _ref5$params = _ref5.params,
        params = _ref5$params === void 0 ? {} : _ref5$params,
        _ref5$otherParams = _ref5.otherParams,
        otherParams = _ref5$otherParams === void 0 ? {} : _ref5$otherParams,
        getFieldValue = _ref5.form.getFieldValue,
        match = _ref5.match,
        bind = _ref5.bind,
        funcCallBackParams = _ref5.funcCallBackParams;

    //这个方法会在输入控件的组件中调用，在输入组件中的funcCallBackParams并不是一个func 
    var _funcCallBackParams = typeof funcCallBackParams === "function" ? funcCallBackParams() : funcCallBackParams;

    params = bind(params)(_objectSpread$3({}, _funcCallBackParams));
    otherParams = bind(otherParams)(_objectSpread$3({}, _funcCallBackParams));
    var fetchParams = {};

    if (params) {
      //从表单中或者路由中取值
      var routeParams = match.params;

      for (var key in params) {
        if (params.hasOwnProperty(key)) {
          fetchParams[key] = getFieldValue(params[key]) || routeParams[params[key]];
        }
      }
    }

    return _objectSpread$3({}, fetchParams, {}, otherParams);
  },
  //文件上传后转换
  normFile: function normFile(e) {
    var fileList = e.fileList;
    var newFileList = fileList.map(function (item, index) {
      //当失败时弹出失败信息。但是有时候成功需要弹出信息时也可以将success设置为false 
      if (item && item.response && !item.response.success) {
        if (index === fileList.length - 1) {
          tool.msg.info(item.response.message);
        }
      }

      if (item.response && item.response.success && item.response.data) {
        if (!item.response.data.uid) {
          item.response.data.uid = index;
        }

        var res = item.response.data; //移动端上传时候需要将返回的url地址改为mobileUrl

        var obj = _objectSpread$3({}, res, {
          url: isMobile() ? res.mobileUrl : res.url,
          status: "done",
          fileName: res.name || res.fileName,
          fileUrl: res.url || res.fileUrl
        });

        return obj;
      }

      return _objectSpread$3({}, item);
    });
    return newFileList;
  },
  //设置输入框触礁后自动居中
  setInputAlignMiddle: function setInputAlignMiddle() {
    $(function () {
      if (isMobile()) {
        setTimeout(function () {
          $(".QnnFormContent input, .QnnFormContent textarea").on("click", function (e) {
            var target = this;
            var thisType = $(this).attr("type");
            if (thisType === "radio" || thisType === "checkbox") return;
            setTimeout(function () {
              target.scrollIntoView({
                block: "center",
                inline: "center"
              });
            }, 450);
          });
          $(".QnnFormContent input, .QnnFormContent textarea").on("blur", function () {
            var thisType = $(this).attr("type");

            if (thisType === "radio" || thisType === "checkbox") {
              return;
            } //微信网页中 让ios还原


            setTimeout(function () {
              window.scrollTo(0, document.body.scrollTop + 1);
              document.body.scrollTop >= 1 && window.scrollTo(0, document.body.scrollTop - 1);
            }, 10);
          });
          $(window).resize(function () {
            //微信网页中 让ios还原
            setTimeout(function () {
              window.scrollTo(0, document.body.scrollTop + 1);
              document.body.scrollTop >= 1 && window.scrollTo(0, document.body.scrollTop - 1);
            }, 10);
          });
        }, 600);
      }
    });
  },
  //获取jsx渲染方式中的所有字段配置
  // @children  qnnForm.props.children
  getFieldsByJSX: function getFieldsByJSX() {
    var children = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var formConfig = []; //jsx风格递归子集

    var loopChildren = function loopChildren(childrenData) {
      return React__default.Children.map(childrenData, function (child) {
        var cloneChild = immutable.fromJS(_objectSpread$3({}, child)).toJS();
        var childProps = cloneChild.props;
        var childChildrenData = childProps === null || childProps === void 0 ? void 0 : childProps.children;

        if (childChildrenData && _typeof(childChildrenData) === "object") {
          loopChildren(childChildrenData);
        } else {
          if (childProps === null || childProps === void 0 ? void 0 : childProps.field) {
            // 是Field字段
            formConfig.push(childProps);
          }
        }

        return cloneChild;
      });
    };

    loopChildren(children);
    return formConfig;
  },
  // 读取所有子集配置 也就是parent链接
  // @formConfig  总字段配置 
  // @field  总字段配置 
  // ()=>无限联动子集关系链 {..., realField:表单块中的字段会拼接上表单块id}
  getChildren: function getChildren() {
    var formConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var field = arguments.length > 1 ? arguments[1] : undefined;
    var children = [];

    var getFn = function getFn() {
      var formConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var field = arguments.length > 1 ? arguments[1] : undefined;
      //是联动字段在切换值时候需要寻找子字段，并且给子字段设置下拉选项
      var childFieldByInFormBlock; //用于储存下拉值的key使用 

      var blockField; //如果子集在表单块中，那就需要在把子集field给到该变量

      var blockChildField;
      var childField = formConfig.filter(function (item) {
        var formFields = item.formFields,
            type = item.type,
            _item$qnnFormConfig2 = item.qnnFormConfig,
            qnnFormConfig = _item$qnnFormConfig2 === void 0 ? {} : _item$qnnFormConfig2;

        if (type === "qnnForm") {
          //兼容写法(不建议写qnnFormConfig，推荐使用formFields)
          var qnnFormConfig_formConfig = qnnFormConfig.formConfig;
          var fields = formFields ? formFields : qnnFormConfig_formConfig;
          childFieldByInFormBlock = fields.filter(function (childFieldCon) {
            return childFieldCon.parent === (Array.isArray(field) ? field.join('.') : field);
          })[0]; //拿到表单块的 块id

          if (childFieldByInFormBlock) {
            blockField = item.field;
            blockChildField = childFieldByInFormBlock.field;
          }
        } //field可能是个数组，因为在表单块里的字段field都是数组 是数组的话需要用逗号拼接下


        return item.parent === (Array.isArray(field) ? field.join('.') : field) || childFieldByInFormBlock;
      })[0];

      if (childField) {
        var _fieldConfig = childFieldByInFormBlock || childField;

        var realField = blockField ? "".concat(blockField, ".").concat(blockChildField ? blockChildField : _fieldConfig.field) : _fieldConfig.field;
        children.push(_objectSpread$3({}, childField, {
          realField: Array.isArray(realField) ? realField.join('.') : realField
        })); //继续继续递归

        getFn(formConfig, childField.field);
      }
    };

    getFn(formConfig, field);
    return children;
  }
};

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var getValues = function getValues(isValidate, cb) {
  var _this = this;

  var _this$state = this.state,
      _this$state$tabs = _this$state.tabs,
      tabs = _this$state$tabs === void 0 ? [] : _this$state$tabs,
      tabsIndex = _this$state.tabsIndex;
  var children = this.props.children; //jsx风格是么有这个的 需要手动查询出来

  var formConfig = immutable.fromJS(this.state.formConfig || []).toJS(); //可能是jsx风格的配置

  if (children && !formConfig.length && !tabs.length) {
    formConfig = tool.getFieldsByJSX(children);
  }

  return new Promise(function (resolve) {
    var fv = function fv(values) {
      return tool.formatData(values, tool.getAllFormField({
        tabs: tabs,
        formConfig: formConfig,
        onlyFormatValue: true
      }), "get");
    };

    if (isValidate) {
      //需要验证字段
      if (isValidate === "curTab" && tabs.length) {
        //只验证当前tab页面的value
        // 获取当前页面的字段项
        var curTabsFormConfigs = tool.getAllFormBlockField(tabs[tabsIndex].content.formConfig).map(function (item) {
          return item.field.split('.');
        });

        _this.form.validateFields(curTabsFormConfigs).then(function (values) {
          resolve(fv(values));
          cb && cb(fv(values));
        }).catch(
        /*#__PURE__*/
        function () {
          var _ref = _asyncToGenerator(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee(errs) {
            var _errs$errorFields$;

            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _this.form.scrollToField((_errs$errorFields$ = errs.errorFields[0]) === null || _errs$errorFields$ === void 0 ? void 0 : _errs$errorFields$.name);

                  case 1:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }());
      } else {
        var _this$form;

        console.assert(_this.form, 'form对象不存在   ---qnnForm getValues提示');
        (_this$form = _this.form) === null || _this$form === void 0 ? void 0 : _this$form.validateFields().then(function (values) {
          resolve(fv(values));
          cb && cb(fv(values));
        }).catch(
        /*#__PURE__*/
        function () {
          var _ref2 = _asyncToGenerator(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee2(errs) {
            var _errs$errorFields, _errs$errorFields$2;

            var errFieldConfig;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    if (errs) {
                      console.error(errs);
                    } //tab错误是跳转到对应tab
                    //只获取第一个错误


                    if (!(tabs === null || tabs === void 0 ? void 0 : tabs.length)) {
                      _context2.next = 7;
                      break;
                    }

                    errFieldConfig = tool.getFieldConfig(errs.errorFields[0].name.join('.'), {
                      formConfig: formConfig,
                      tabs: tabs
                    });

                    if (!(tabsIndex !== errFieldConfig.tabIndex + "")) {
                      _context2.next = 7;
                      break;
                    }

                    _context2.next = 6;
                    return _this.setTabsIndex(errFieldConfig.tabIndex + "");

                  case 6:
                    //因为去设置state后错误被刷没了需要在重新验证一下
                    _this.form.validateFields();

                  case 7:
                    _this.form.scrollToField(errs === null || errs === void 0 ? void 0 : (_errs$errorFields = errs.errorFields) === null || _errs$errorFields === void 0 ? void 0 : (_errs$errorFields$2 = _errs$errorFields[0]) === null || _errs$errorFields$2 === void 0 ? void 0 : _errs$errorFields$2.name);

                  case 8:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }));

          return function (_x2) {
            return _ref2.apply(this, arguments);
          };
        }());
      }
    } else {
      var _this$form2;

      //无需验证字段
      var values = (_this$form2 = _this.form) === null || _this$form2 === void 0 ? void 0 : _this$form2.getFieldsValue();
      resolve(fv(values));
      cb && cb(fv(values));
    }
  });
};

var setValues = function setValues() {
  var _this$form, _this$form$setFieldsV;

  var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _this$state$tabs = this.state.tabs,
      tabs = _this$state$tabs === void 0 ? [] : _this$state$tabs;
  var children = this.props.children; //jsx风格是么有这个的 需要手动查询出来

  var formConfig = immutable.fromJS(this.state.formConfig || []).toJS(); //可能是jsx风格的配置

  if (children && !formConfig.length) {
    //jsx风格递归子集   后期需改react 的子集方法toArray方法进行递归
    formConfig = tool.getFieldsByJSX(children);
  }

  var formatedValues = tool.formatData(values, tool.getAllFormField({
    tabs: tabs,
    formConfig: formConfig
  }), "set"); //判断是否有表单块需要单独设置值 

  var canAddBlocksUpdateValueFn = this.getCanAddBlocksUpdateValueFn();

  for (var key in canAddBlocksUpdateValueFn) {
    var canAddBlockItem = canAddBlocksUpdateValueFn[key];
    var blockValus = tool.getDataValByField(key, formatedValues);
    blockValus && canAddBlockItem(blockValus);
  }

  (_this$form = this.form) === null || _this$form === void 0 ? void 0 : (_this$form$setFieldsV = _this$form.setFieldsValue) === null || _this$form$setFieldsV === void 0 ? void 0 : _this$form$setFieldsV.call(_this$form, formatedValues);
};

function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(Object(source), true).forEach(function (key) { _defineProperty$4(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$4(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var setTabsIndex = function setTabsIndex(index) {
  var _this = this;

  return new Promise(function (resolve) {
    _this.setState({
      tabsIndex: index
    }, function () {
      var _this$props, _this$props$setTabsIn, _this$props2, _this$props2$onTabsCh;

      resolve(index);

      _this.getTabsValueByFetch(); //在抽屉中需要去吧tabIndex同步到表格中 


      (_this$props = _this.props) === null || _this$props === void 0 ? void 0 : (_this$props$setTabsIn = _this$props.setTabsIndex) === null || _this$props$setTabsIn === void 0 ? void 0 : _this$props$setTabsIn.call(_this$props, index, false);
      (_this$props2 = _this.props) === null || _this$props2 === void 0 ? void 0 : (_this$props2$onTabsCh = _this$props2.onTabsChange) === null || _this$props2$onTabsCh === void 0 ? void 0 : _this$props2$onTabsCh.call(_this$props2, index, _objectSpread$4({}, _this.funcCallBackParams()));
    });
  });
};

function ownKeys$5(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$5(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$5(Object(source), true).forEach(function (key) { _defineProperty$5(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$5(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$5(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator$1(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep$1(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var refresh = function refresh(fetchConfig) {
  var _this = this;

  // console.log("%c请求数据",'color:green;font-size:20px', fetchConfig); 
  return new Promise(
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator$1(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(resolve) {
      var _this$state, formConfig, data, values, match, _fetchConfig, apiName, params, otherParams, success, _successCB, _params, resData, _success, _data, message;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$state = _this.state, formConfig = _this$state.formConfig, data = _this$state.data, values = _this$state.values;
              fetchConfig = fetchConfig || _this.state.fetchConfig;
              match = _this.props.match;
              fetchConfig = _this.bind(fetchConfig)(_objectSpread$5({}, _this.funcCallBackParams()));
              _fetchConfig = fetchConfig, apiName = _fetchConfig.apiName, params = _fetchConfig.params, otherParams = _fetchConfig.otherParams, success = _fetchConfig.success;
              _successCB = success;
              apiName = _this.bind(apiName)(_objectSpread$5({}, _this.funcCallBackParams())); //需要去请求字段项然后渲染

              formConfig.fetchConfig && _this.getFieldsInsertForm(); //因为联动下拉需要获取到字段的值来设置子级数据所以先设置值，然后社遏制下拉选项
              //请求默认值  

              if (!apiName) {
                _context.next = 21;
                break;
              }

              _params = tool.getFetchParams({
                params: params,
                otherParams: otherParams,
                match: match,
                form: _this.form,
                bind: _this.bind,
                funcCallBackParams: _this.funcCallBackParams
              });

              _this.qnnSetState({
                loadingByForm: true,
                isNeedRefresh: false
              });

              _context.next = 13;
              return _this.fetch(apiName, _params);

            case 13:
              resData = _context.sent;
              _success = resData.success, _data = resData.data, message = resData.message;

              _this.qnnSetState({
                loadingByForm: false
              });

              if (_success) {
                if (Array.isArray(_data)) {
                  _data = _data[0];
                }

                _this.setValues(_data);

                !values && _this.qnnSetState({
                  values: _data
                });
              } else {
                tool.msg.error(message);
              } //回调执行


              _successCB && _this.bind(_successCB)(resData, _this.funcCallBackParams());
              resolve(_objectSpread$5({
                response: resData
              }, _this.funcCallBackParams()));
              _context.next = 22;
              break;

            case 21:
              if (data && JSON.stringify(data) !== '{}') {
                //设置死数据     
                _this.setValues(data);

                !values && _this.qnnSetState({
                  values: data
                });
                resolve(_objectSpread$5({
                  response: data
                }, _this.funcCallBackParams()));
              }

            case 22:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());
};

var css = ".drag_noselect__16sGL {\n  -webkit-touch-callout: none;\n  /* iOS Safari */\n  -webkit-user-select: none;\n  /* Chrome/Safari/Opera */\n  /* Konqueror */\n  -moz-user-select: none;\n  /* Firefox */\n  -ms-user-select: none;\n  /* Internet Explorer/Edge */\n  user-select: none;\n  /* Non-prefixed version, currently\n    \n    not supported by any browser */\n}\n.drag_onDragStart__2QBvL {\n  opacity: 0.3;\n  -webkit-transition: 0.3s;\n  -o-transition: 0.3s;\n  transition: 0.3s;\n}\n.drag_onDragStart__2QBvL * {\n  pointer-events: none;\n  -webkit-touch-callout: none;\n  /* iOS Safari */\n  -webkit-user-select: none;\n  /* Chrome/Safari/Opera */\n  /* Konqueror */\n  -moz-user-select: none;\n  /* Firefox */\n  -ms-user-select: none;\n  /* Internet Explorer/Edge */\n  user-select: none;\n  /* Non-prefixed version, currently\n    \n    not supported by any browser */\n}\n.drag_onDragEnter__3yaqS {\n  background: rgba(255, 192, 203, 0.4);\n  -webkit-transition: 0.3s;\n  -o-transition: 0.3s;\n  transition: 0.3s;\n}\n.drag_onDragEnter__3yaqS * {\n  pointer-events: none;\n  -webkit-touch-callout: none;\n  /* iOS Safari */\n  -webkit-user-select: none;\n  /* Chrome/Safari/Opera */\n  /* Konqueror */\n  -moz-user-select: none;\n  /* Firefox */\n  -ms-user-select: none;\n  /* Internet Explorer/Edge */\n  user-select: none;\n  /* Non-prefixed version, currently\n    \n    not supported by any browser */\n}\n.drag_beforeInsert__1lyJq {\n  border-left: 6px solid #1890ff;\n  -webkit-transition: 0.3s;\n  -o-transition: 0.3s;\n  transition: 0.3s;\n  -webkit-box-sizing: border-box;\n          box-sizing: border-box;\n}\n.drag_afterInsert__1AdPh {\n  border-right: 6px solid #1890ff;\n  -webkit-transition: 0.3s;\n  -o-transition: 0.3s;\n  transition: 0.3s;\n  -webkit-box-sizing: border-box;\n          box-sizing: border-box;\n}\n";
var style = {
  "noselect": "drag_noselect__16sGL",
  "onDragStart": "drag_onDragStart__2QBvL",
  "onDragEnter": "drag_onDragEnter__3yaqS",
  "beforeInsert": "drag_beforeInsert__1lyJq",
  "afterInsert": "drag_afterInsert__1AdPh"
};
styleInject_es.styleInject(css);

function _typeof$1(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$1 = function _typeof(obj) { return typeof obj; }; } else { _typeof$1 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$1(obj); }

function _toConsumableArray$1(arr) { return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _nonIterableSpread$1(); }

function _nonIterableSpread$1() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray$1(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles$1(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof$1(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var unit =
/*#__PURE__*/
function () {
  function unit() {
    _classCallCheck(this, unit);
  }

  _createClass(unit, [{
    key: "addClass",
    value: function addClass(dom, className) {
      var _oldClass, _oldClass$replace;

      var oldClass = dom.getAttribute("class");
      oldClass = "".concat((_oldClass = oldClass) === null || _oldClass === void 0 ? void 0 : (_oldClass$replace = _oldClass.replace) === null || _oldClass$replace === void 0 ? void 0 : _oldClass$replace.call(_oldClass, className, ''), " ").concat(className, " ");
      dom.setAttribute("class", oldClass);
      dom.className = oldClass;
    }
  }, {
    key: "removeClass",
    value: function removeClass(dom, className) {
      var _oldClass2, _oldClass2$replace;

      var oldClass = dom.getAttribute("class");
      oldClass = (_oldClass2 = oldClass) === null || _oldClass2 === void 0 ? void 0 : (_oldClass2$replace = _oldClass2.replace) === null || _oldClass2$replace === void 0 ? void 0 : _oldClass2$replace.call(_oldClass2, new RegExp(className, 'g'), '');
      dom.setAttribute("class", oldClass);
      dom.className = oldClass;
    }
  }]);

  return unit;
}(); //pc端上的拖动事件


var FieldDragFns =
/*#__PURE__*/
function (_unit) {
  _inherits(FieldDragFns, _unit);

  //当前拖动的dom id
  //需要插入到目标元素的前面还是后面
  function FieldDragFns(field) {
    var _this;

    _classCallCheck(this, FieldDragFns);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FieldDragFns).call(this));
    _this.field = field;
    _this.domIncClassExg = /(formItemCol)/g;
    _this.startX; //移动端拖动时缓存的目标元素

    _this.targetColEle; //移动端上被拖动的元素

    _this.dragDom;
    return _this;
  } //通用事件
  //@target 被拖拽元素触摸的dom


  _createClass(FieldDragFns, [{
    key: "endEdSetStyle",
    value: function endEdSetStyle(targetDom) {
      var _this2 = this;

      //恢复被拖拽的dom样式
      var dragDom = document.querySelector("#".concat(FieldDragFns.dragDomId));
      this.removeClass(dragDom, style.onDragStart); //恢复被触摸dom的样式

      if (targetDom) {
        this.removeClass(targetDom, style.beforeInsert);
        this.removeClass(targetDom, style.afterInsert);
      } //为了确保无问题 将所有输入控件的拖拽中的样式全部删除


      var formItemCols = document.querySelectorAll(".qnn-form-formItemCol");
      formItemCols.forEach(function (element) {
        return _this2.removeClass(element, style.onDragEnter);
      });
    }
  }, {
    key: "getNewFormConfig",
    value: function getNewFormConfig(formConfig, dragField, targetField) {
      var insetDir = FieldDragFns.targetDir;
      var newFormConfig = [].concat(_toConsumableArray$1(formConfig)); //整理配置数据 调用回调
      //获取被拖动的字段索引
      //获取目标字段索引

      var dragIndex = 0;
      var targetIndex = 0;

      for (var i = 0, j = formConfig.length; i < j; i++) {
        if (formConfig[i].field === dragField) {
          dragIndex = i;
        }

        if (formConfig[i].field === targetField) {
          targetIndex = i;
        }
      } //删除被拖动的元素


      var dragFieldConfig = newFormConfig.splice(dragIndex, 1);
      var realInsetIndex = targetIndex; //以下情况无需进行排序
      //1、后一个控件拖拽到前一个控件的后面 位置其实是不变的
      //1、前一个控件拖拽到后一个控件的前面 位置其实是不变的

      var xiangLing1 = dragIndex - targetIndex === 1 && insetDir === 'after';
      var xiangLing2 = dragIndex - targetIndex === -1 && insetDir === 'before';

      if (xiangLing1 || xiangLing2) {
        return {};
      }

      if (Math.abs(targetIndex - dragIndex) === 1) {
        //相邻两个控件的插入规则
        realInsetIndex = insetDir === 'before' ? Math.max(targetIndex, 0) : targetIndex;
      } else if (targetIndex > dragIndex) {
        //将控件往后面拖拽 向后拖拽后需要在插入的索引位置在 - 1因为自己本身也算一个索引
        realInsetIndex = (insetDir === 'before' ? targetIndex : targetIndex + 1) - 1;
      } else if (targetIndex < dragIndex) {
        //将控件往前面拖拽
        realInsetIndex = insetDir === 'before' ? targetIndex : targetIndex + 1;
      } //将删除的元素插入到目标元素前


      newFormConfig.splice(realInsetIndex, 0, dragFieldConfig[0]);
      return {
        newFormConfig: _toConsumableArray$1(newFormConfig),
        realInsetIndex: realInsetIndex,
        dragIndex: dragIndex,
        targetIndex: targetIndex
      };
    } //pc端事件

  }, {
    key: "onDragStart",
    value: function onDragStart(event, onDragStartCb) {
      event.stopPropagation(); // 设置拖动节点信息 在放置时候可被放置节点获取到

      event.dataTransfer.setData("field", this.field);
      FieldDragFns.dragDomId = event.target.getAttribute("id");
      this.addClass(event.target, style.onDragStart);
      onDragStartCb && onDragStartCb({
        dragField: this.field
      });
    }
  }, {
    key: "onDragOver",
    value: function onDragOver(event) {
      //这样就将该元素变为了可放置元素 
      event.preventDefault();

      if (event.target.id !== FieldDragFns.dragDomId) {
        this.addClass(event.target, style.onDragEnter); //判断是前插入dom 还是后插入dom 

        if (!this.startX) {
          this.startX = event.target.offsetWidth / 2 + event.target.offsetLeft;
        }

        var containerLeft = document.querySelector('.fieldCanDragQnnForm').offsetLeft;

        if (this.startX - (event.clientX - containerLeft) > 0) {
          //向前插入 
          this.removeClass(event.target, style.afterInsert);
          this.addClass(event.target, style.beforeInsert);
          FieldDragFns.targetDir = 'before';
        } else {
          //向后插入 
          this.removeClass(event.target, style.beforeInsert);
          this.addClass(event.target, style.afterInsert);
          FieldDragFns.targetDir = 'after';
        }
      }
    }
  }, {
    key: "onDragEnter",
    value: function onDragEnter(event) {
      if (this.domIncClassExg.test(event.target.getAttribute("class")) && event.target.id !== FieldDragFns.dragDomId) {
        this.addClass(event.target, style.onDragEnter);
      }
    }
  }, {
    key: "onDragLeave",
    value: function onDragLeave(event) {
      this.removeClass(event.target, style.onDragEnter);
      this.startX = undefined;
      this.removeClass(event.target, style.beforeInsert);
      this.removeClass(event.target, style.afterInsert);
    }
  }, {
    key: "onDrop",
    value: function onDrop(event) {
      var formConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var fieldDragCb = arguments.length > 2 ? arguments[2] : undefined;
      //样式恢复 
      this.endEdSetStyle(event.target); //拖动逻辑操作

      if (event.target.id !== FieldDragFns.dragDomId) {
        var dragField = event.dataTransfer.getData("field");
        var targetField = event.target.getAttribute("field");
        var insetDir = FieldDragFns.targetDir;

        var _this$getNewFormConfi = this.getNewFormConfig([].concat(_toConsumableArray$1(formConfig)), dragField, targetField),
            newFormConfig = _this$getNewFormConfi.newFormConfig,
            realInsetIndex = _this$getNewFormConfi.realInsetIndex,
            dragIndex = _this$getNewFormConfi.dragIndex,
            targetIndex = _this$getNewFormConfi.targetIndex;

        if (newFormConfig) {
          //执行回调
          fieldDragCb({
            dragField: dragField,
            targetField: targetField,
            insetDir: insetDir,
            dragIndex: dragIndex,
            targetIndex: targetIndex,
            insetIndex: realInsetIndex,
            oldFormConfig: [].concat(_toConsumableArray$1(formConfig)),
            newFormConfig: [].concat(_toConsumableArray$1(newFormConfig))
          });
        }
      }
    }
  }, {
    key: "onDragEnd",
    value: function onDragEnd(event) {
      this.endEdSetStyle(event.target);
    } //移动端事件
    //移动端获取被触摸元素
    //@event touchEvent

  }, {
    key: "getTargetDom",
    value: function getTargetDom(event) {
      var _this3 = this;

      var toucheOne = event.touches[0] || event.changedTouches[0];
      var targetEles = document.elementsFromPoint(toucheOne.clientX, toucheOne.clientY); //找出qnn-form-formItemCol 并且取出元素id

      return targetEles.filter(function (element) {
        return _this3.domIncClassExg.test(element.className);
      })[0];
    }
  }, {
    key: "onTouchStart",
    value: function onTouchStart(event, onTouchStartCb) {
      //找出qnn-form-formItemCol 并且取出元素id
      var targetColEle = this.getTargetDom(event);
      FieldDragFns.dragDomId = targetColEle.id;
      this.addClass(targetColEle, style.onDragStart); //克隆一个元素插入到dom中

      this.dragDom = targetColEle.cloneNode(false);
      this.dragDom.setAttribute("id", "qnnFormDragDom");
      this.dragDom.style.height = '39px';
      this.dragDom.style.background = 'rgba(24, 144, 255, 0.6)';
      var container = document.querySelector('.fieldCanDragQnnForm');
      container.appendChild(this.dragDom);
      onTouchStartCb && onTouchStartCb({
        dragField: this.dragDom.getAttribute("field")
      });
    }
  }, {
    key: "onTouchMove",
    value: function onTouchMove(event) {
      var _this$targetColEle;

      event.preventDefault(); //获取位置的顶层dom

      var targetColEle = this.getTargetDom(event); //在非输入控件上时候 清空样式和开始的坐标

      if (targetColEle && this.domIncClassExg.test(targetColEle.className)) {
        this.startX = undefined;
      } //如果缓存的target存在的话需要清除样式


      if (this.targetColEle && targetColEle && ((_this$targetColEle = this.targetColEle) === null || _this$targetColEle === void 0 ? void 0 : _this$targetColEle.id) !== (targetColEle === null || targetColEle === void 0 ? void 0 : targetColEle.id)) {
        this.removeClass(this.targetColEle, style.afterInsert);
        this.removeClass(this.targetColEle, style.beforeInsert);
        this.removeClass(this.targetColEle, style.onDragEnter);
      } //被拖拽的图标


      if (this.dragDom) {
        //设置被拖动的元素 样式 
        this.dragDom.style.position = "fixed";
        this.dragDom.style.zIndex = 3;
        this.dragDom.style.opacity = 0.8;
        this.dragDom.style.background = "rgba(24, 144, 255, 0.6)";
        this.dragDom.style.transform = "scale(0.7)";
        this.dragDom.style.left = event.touches[0].clientX - this.dragDom.offsetWidth / 4 + 'px';
        this.dragDom.style.top = event.touches[0].clientY - 20 + 'px';
      } //进行逻辑操作


      if (targetColEle && this.domIncClassExg.test(targetColEle.className) && targetColEle.id !== FieldDragFns.dragDomId) {
        this.addClass(targetColEle, style.onDragEnter); //判断是前插入dom 还是后插入dom 

        if (!this.startX) {
          this.startX = targetColEle.offsetWidth / 2 + targetColEle.offsetLeft;
        }

        var containerLeft = document.querySelector('.fieldCanDragQnnForm').offsetLeft;

        if (this.startX - (event.changedTouches[0].clientX - containerLeft) > 0) {
          //向前插入 
          this.removeClass(targetColEle, style.afterInsert);
          this.addClass(targetColEle, style.beforeInsert);
          FieldDragFns.targetDir = 'before';
        } else {
          //向后插入 
          this.removeClass(targetColEle, style.beforeInsert);
          this.addClass(targetColEle, style.afterInsert);
          FieldDragFns.targetDir = 'after';
        } //缓存一下目标元素


        this.targetColEle = targetColEle;
      }
    }
  }, {
    key: "onTouchEnd",
    value: function onTouchEnd(event) {
      var formConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var fieldDragCb = arguments.length > 2 ? arguments[2] : undefined;
      var targetColEle = this.getTargetDom(event); //样式恢复 

      this.endEdSetStyle(this.targetColEle);
      this.removeClass(this.targetColEle, style.afterInsert);
      this.removeClass(this.targetColEle, style.beforeInsert); //删除被拖拽元素 

      var container = document.querySelector('.fieldCanDragQnnForm');

      if (document.querySelector('#qnnFormDragDom')) {
        container.removeChild(document.querySelector('#qnnFormDragDom'));
      }

      if (targetColEle && targetColEle.id !== FieldDragFns.dragDomId) {
        var dragField = this.dragDom.getAttribute("field");
        var targetField = targetColEle.getAttribute("field");
        var insetDir = FieldDragFns.targetDir;

        var _this$getNewFormConfi2 = this.getNewFormConfig([].concat(_toConsumableArray$1(formConfig)), dragField, targetField),
            newFormConfig = _this$getNewFormConfi2.newFormConfig,
            realInsetIndex = _this$getNewFormConfi2.realInsetIndex,
            dragIndex = _this$getNewFormConfi2.dragIndex,
            targetIndex = _this$getNewFormConfi2.targetIndex; // console.log(dragField, targetField, dragIndex,targetIndex, newFormConfig); 


        if (newFormConfig) {
          //执行回调
          fieldDragCb({
            dragField: dragField,
            targetField: targetField,
            insetDir: insetDir,
            dragIndex: dragIndex,
            targetIndex: targetIndex,
            insetIndex: realInsetIndex,
            oldFormConfig: [].concat(_toConsumableArray$1(formConfig)),
            newFormConfig: [].concat(_toConsumableArray$1(newFormConfig))
          });
        }
      }
    } //被系统电话等操作打断

  }, {
    key: "onTouchCancel",
    value: function onTouchCancel() {}
  }]);

  return FieldDragFns;
}(unit);

FieldDragFns.dragDomId = undefined;
FieldDragFns.targetDir = undefined;

exports.FieldDragFns = FieldDragFns;
exports._BindComKey = BindComKey;
exports.bind = bind;
exports.getDeviceType = getDeviceType;
exports.getInitialValues = getInitialValues;
exports.getInputProps = getInputProps;
exports.getMessageType = getMessageType;
exports.getRules = getRules;
exports.getStrTmp = getStrTmp;
exports.getValues = getValues;
exports.loopClearChild = loopClearChild;
exports.refresh = refresh;
exports.setTabsIndex = setTabsIndex;
exports.setValues = setValues;
exports.tool = tool;
